package juliac.generated;

import org.osoa.sca.CallableReference;
import org.objectweb.fractal.api.Component;
import java.lang.reflect.Constructor;
import org.objectweb.fractal.julia.Controller;
import org.objectweb.fractal.julia.loader.Generated;
import org.objectweb.fractal.julia.InitializationContext;
import org.objectweb.fractal.api.factory.InstantiationException;
import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.api.NoSuchInterfaceException;
import org.ow2.frascati.tinfi.control.component.ReconfigurableComponentContext;
import org.osoa.sca.RequestContext;
import org.ow2.frascati.tinfi.control.content.SCAContentController;
import org.ow2.frascati.tinfi.control.property.SCAPropertyController;
import org.osoa.sca.ServiceReference;
import org.ow2.frascati.tinfi.osoa.ServiceReferenceImpl;
import org.ow2.frascati.tinfi.TinfiRuntimeException;
import org.objectweb.fractal.api.Type;

/** 
 * @see org.objectweb.fractal.julia.BasicControllerMixin
 * @see org.objectweb.fractal.julia.UseComponentMixin
 * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin
 * @see org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin
 * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin
 */
public class SCAComponentContextControllerImpl implements Controller , Generated , ReconfigurableComponentContext {
    /** 
     * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$0(final InitializationContext ic) throws InstantiationException {
        weaveableSCACC = ((SCAContentController)(ic.interfaces.get(SCAContentController.NAME)));
        initFcController$1(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    public void initFcController(final InitializationContext ic) throws InstantiationException {
        weaveableSCAPC = ((SCAPropertyController)(ic.interfaces.get(SCAPropertyController.NAME)));
        initFcController$0(ic);
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableC
     */
    public Component weaveableC;
    
    /** 
     * @see org.objectweb.fractal.julia.BasicControllerMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$2(final InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getURI()
     */
    public String getURI() throws UnsupportedOperationException {
        throw new UnsupportedOperationException();
    }
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#weaveableOptC
     */
    public Component weaveableOptC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin#weaveableSCACC
     */
    @SuppressWarnings(value = "unused")
    private SCAContentController weaveableSCACC;
    
    /** 
     * @see org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin#weaveableSCAPC
     */
    @SuppressWarnings(value = "unused")
    private SCAPropertyController weaveableSCAPC;
    
    /** 
     * @see org.objectweb.fractal.julia.UseComponentMixin#initFcController(org.objectweb.fractal.julia.InitializationContext)
     */
    private void initFcController$1(final InitializationContext ic) throws InstantiationException {
        weaveableC = ((Component)(ic.getInterface("component")));
        weaveableOptC = weaveableC;
        initFcController$2(ic);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#cast(B)
     */
    public <B, R extends org.osoa.sca.CallableReference<B>> R cast(B target) throws IllegalArgumentException {
        if (!(target instanceof ServiceReference<?> )) {
            String msg = "Not a reference: " + target;
            throw new IllegalArgumentException(msg);
        } 
        ServiceReference<?>  ci = ((ServiceReference<?> )(target));
        Class<?>  businessInterface = ci.getBusinessInterface();
        Object service = ci.getService();
        String signature = businessInterface.getName();
        String clname = signature + "FcSR";
        try {
            Class<?>  cl = Class.forName(clname);
            Constructor<?> [] ctrs = cl.getConstructors();
            Constructor<?>  ctr = ctrs[0];
            Object sr = ctr.newInstance(businessInterface ,service);
            @SuppressWarnings(value = "unchecked")
            R ret = ((R)(sr));
            return ret;
        } catch (Exception e) {
            throw new IllegalArgumentException(e);
        }
    }
    
    private void initFcController$3(InitializationContext ic) throws InstantiationException {
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getService(java.lang.Class,java.lang.String)
     */
    public <B> B getService(Class<B>  businessInterface, String referenceName) throws TinfiRuntimeException {
        Interface itf = null;
        try {
            itf = ((Interface)(weaveableC.getFcInterface(referenceName)));
        } catch (NoSuchInterfaceException e) {
            throw new TinfiRuntimeException(e);
        }
        InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
        if (!(it.isFcClientItf())) {
            String msg = "No such reference: " + referenceName;
            throw new TinfiRuntimeException(msg);
        } 
        if (!(businessInterface.isAssignableFrom(itf.getClass()))) {
            String msg = "Reference can not be casted to: " + (businessInterface.getClass());
            throw new TinfiRuntimeException(msg);
        } 
        @SuppressWarnings(value = "unchecked")
        B ret = ((B)(itf));
        return ret;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getServiceReference(java.lang.Class,java.lang.String)
     */
    public <B> ServiceReference<B>  getServiceReference(Class<B>  businessInterface, String referenceName) {
        B service = getService(businessInterface ,referenceName);
        ServiceReference<B>  sr = new ServiceReferenceImpl<B> (businessInterface , service);
        return sr;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getProperty(java.lang.Class,java.lang.String)
     */
    public <B> B getProperty(Class<B>  type, String propertyName) throws IllegalArgumentException {
        if (!(weaveableSCAPC.containsPropertyName(propertyName))) {
            String msg = "No such property: " + propertyName;
            throw new IllegalArgumentException(msg);
        } 
        Object value = weaveableSCAPC.getValue(propertyName);
        try {
            @SuppressWarnings(value = "unchecked")
            B ret = ((B)(value));
            return ret;
        } catch (ClassCastException cce) {
            String msg = (("Property " + propertyName) + " is not of type ") + (type.getName());
            throw new IllegalArgumentException(msg);
        }
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#createSelfReference(java.lang.Class)
     */
    public <B> ServiceReference<B>  createSelfReference(Class<B>  businessInterface) {
        B service = getServ(businessInterface);
        ServiceReference<B>  sr = new ServiceReferenceImpl<B> (businessInterface , service);
        return sr;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#createSelfReference(java.lang.Class,java.lang.String)
     */
    public <B> ServiceReference<B>  createSelfReference(Class<B>  businessInterface, String serviceName) {
        B service = getServ(businessInterface ,serviceName);
        ServiceReference<B>  sr = new ServiceReferenceImpl<B> (businessInterface , service);
        return sr;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getRequestContext()
     */
    public RequestContext getRequestContext() {
        RequestContext rc = weaveableSCACC.peekRequestContext();
        return rc;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getFcComponent()
     */
    public Component getFcComponent() {
        return weaveableC;
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getServ(java.lang.Class)
     */
    private <B> B getServ(Class<B>  businessInterface) throws TinfiRuntimeException {
        Object[] itfs = weaveableC.getFcInterfaces();
        for (Object o : itfs) {
            Interface itf = ((Interface)(o));
            InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
            if (!(it.isFcClientItf())) {
                if (businessInterface.isAssignableFrom(itf.getClass())) {
                    @SuppressWarnings(value = "unchecked")
                    B ret = ((B)(itf));
                    return ret;
                } 
            } 
        }
        String msg = "No such default service";
        throw new TinfiRuntimeException(msg);
    }
    
    /** 
     * @see org.ow2.frascati.tinfi.control.component.ComponentContextMixin#getServ(java.lang.Class,java.lang.String)
     */
    private <B> B getServ(Class<B>  businessInterface, String serviceName) throws TinfiRuntimeException {
        Interface itf = null;
        try {
            itf = ((Interface)(weaveableC.getFcInterface(serviceName)));
        } catch (NoSuchInterfaceException e) {
            throw new TinfiRuntimeException(e);
        }
        InterfaceType it = ((InterfaceType)(itf.getFcItfType()));
        if (it.isFcClientItf()) {
            String msg = "No such service: " + serviceName;
            throw new TinfiRuntimeException(msg);
        } 
        if (!(businessInterface.isAssignableFrom(itf.getClass()))) {
            String msg = "Service can not be casted to: " + (businessInterface.getClass());
            throw new TinfiRuntimeException(msg);
        } 
        @SuppressWarnings(value = "unchecked")
        B ret = ((B)(itf));
        return ret;
    }
    
    public String getFcGeneratorParameters() {
        return "(org.objectweb.fractal.juliac.spoon.MixinClassGenerator juliac.generated.SCAComponentContextControllerImpl org.objectweb.fractal.julia.BasicControllerMixin org.objectweb.fractal.julia.UseComponentMixin org.ow2.frascati.tinfi.control.content.UseSCAContentControllerMixin org.ow2.frascati.tinfi.control.property.UseSCAPropertyControllerMixin org.ow2.frascati.tinfi.control.component.ComponentContextMixin)";
    }
    
}

